#include<bits/stdc++.h>
using namespace std;

vector<std::pair<string, int>> seq_types = {
	{ "random", 0 },
	{ "emil", 0 },
	{ "emil_swap", 0 },
	{ "chunks", 0 },
	{ "tree", 0 },
	{ "one", 0 },
	{ "all_same", 0 },
	{ "large_elements", 0 },
	{ "useful_large_elements", 0 },
	{ "perm", 0 },
	{ "emil_chunkswap", 0}
};
vector<string> qry_types = {"exhaust", "random", "long"};

int xx = 2, sseed;
int seed(){
	sseed ++;
	return sseed;
}

string f(){
	string t;
	int x = xx;
	t += x % 10 + '0'; x /= 10;
	t += x % 10 + '0'; x /= 10;
	t += x % 10 + '0'; x /= 10;
	reverse(t.begin(), t.end());
	++ xx; return t;
}

int main(){
	cout << "g++ -o testgen testgen.cpp" << endl;
	// q = 1
	cout << "#subtask\n";
	for(auto n : {500, 5000, 300000}){
		for(auto seq_type : seq_types){
			cout << "./testgen --n " << n << " --q 1 --seq_type " << seq_type.first << " --seq_param " << seq_type.second << " --qry_type none --seed " << seed() << " > test." << f() << ".in" << endl;
		}
		{
			int low = 1, high = n, ans = 0;
			while(low <= high){
				int mid = (low + high) / 2;
				if(1LL * mid * (mid + 1) / 2 <= n){
					ans = mid;
					low = mid + 1;
				}
				else{
					high = mid - 1;
				}
			}
			cout << "./testgen --n " << ans * (ans + 1) / 2 << " --q 1 --seq_type chunks --seq_param 300 --qry_type none --seed 0 > test." << f() << ".in" << endl; 
		}
		cout << "#subtask\n";
	}
	// q > 1
	for(auto n : {300000}){
		for(auto q : {500, 50000, 500000}){
			for(auto seq_type : seq_types){
				for(auto qry_type : qry_types){
					cout << "./testgen --n " << n << " --q " << q << " --seq_type " << seq_type.first << " --seq_param " << seq_type.second << " --qry_type " << qry_type << " --seed " << seed() << " > test." << f() << ".in" << endl;
				}
			}
			if (q >= 125250) {
				cout << "./testgen --n 500 --q 125250 --seq_type random --seq_param 0 --qry_type exhaust --seed 0 > test." << f() << ".in" << endl;
			}
			{
				int low = 1, high = n, ans = 0;
				while(low <= high){
					int mid = (low + high) / 2;
					if(1LL * mid * (mid + 1) / 2 <= n){
						ans = mid;
						low = mid + 1;
					}
					else{
						high = mid - 1;
					}
				}
				cout << "./testgen --n " << ans * (ans + 1) / 2 << " --q " << q << " --seq_type chunks --seq_param 300 --qry_type random --seed 0 > test." << f() << ".in" << endl; 
			}
			cout << "#subtask\n";
		}
	}
	
}
